from hashlib import sha1
from datetime import datetime
import contextlib


@contextlib.contextmanager
def ignored(*exceptions):
    try:
        yield
    except exceptions:
        pass


DATE_FORMAT = "%Y-%m-%dT%H:%M:%S"


def date_from_string(string, format_string=DATE_FORMAT):
    return datetime.strptime(string, format_string) if string else None


def date_to_string(ts, format_string=DATE_FORMAT):
    return datetime.strftime(ts, format_string) if ts else None


def generate_id(name):
    return sha1(name).hexdigest()[:10]


def humanize_duration(duration):
    mins, secs = divmod(duration, 60)
    hours, mins = divmod(mins, 60)
    return '%02d:%02d:%02d' % (hours, mins, secs)
